<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: /builds/eclipse/oniro-core/eddie/linux/communication/include/CoapServer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_88e6415a3128b404f1102a130772bdb6.html">linux</a></li><li class="navelem"><a class="el" href="dir_9d6112f7740eb6b19e6896a373a5986f.html">communication</a></li><li class="navelem"><a class="el" href="dir_046dfdec3fa9891163197d92ca19a5c8.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">CoapServer.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * SPDX-License-Identifier: Apache-2.0</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-FileCopyrightText: Huawei Inc.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * SPDX-FileCopyrightText: Politecnico Di Milano</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef EDDIE_COAPSERVER_H</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define EDDIE_COAPSERVER_H</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;CoapClient.h&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;ResourceDirectory.h&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;coap3/coap.h&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;unordered_map&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;netdb.h&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;cstring&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;sys/ioctl.h&gt;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;net/if.h&gt;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">class </span><a class="code" href="classCoapClient.html">CoapClient</a>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="classCoapServer.html">   26</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCoapServer.html">CoapServer</a> {</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordtype">bool</span> quit = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    coap_context_t *context = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    coap_endpoint_t *endpoint = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <a class="code" href="classCoapClient.html">CoapClient</a> *client;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    std::string my_ip;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    std::string my_port;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    std::thread server_thread;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">static</span> <a class="code" href="classThreadSafeMap.html">ThreadSafeMap&lt;std::string, coap_resource_t *&gt;</a> *resources;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> resource_handler(coap_resource_t *resource, coap_session_t *session, <span class="keyword">const</span> coap_pdu_t *request,</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;                         <span class="keyword">const</span> coap_string_t *query, coap_pdu_t *response);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keywordtype">int</span> init_server(<span class="keyword">const</span> <span class="keywordtype">char</span> *host, <span class="keyword">const</span> <span class="keywordtype">char</span> *port);</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    [[nodiscard]] <span class="keywordtype">bool</span> get_quit() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keywordtype">void</span> set_quit(<span class="keywordtype">bool</span> val);</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classCoapServer.html#ad5149c00a7b9fde3bbaac8f36d2c89ee">   54</a></span>&#160;    <span class="keyword">explicit</span> <a class="code" href="classCoapServer.html#ad5149c00a7b9fde3bbaac8f36d2c89ee">CoapServer</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *host, <span class="keyword">const</span> <span class="keywordtype">char</span> *port);</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classCoapServer.html#a5128aef62364279915b14a50205c1a68">   60</a></span>&#160;    <a class="code" href="classCoapServer.html#a5128aef62364279915b14a50205c1a68">~CoapServer</a>();</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="classCoapServer.html#a5eb9e35199e0e9d72765ca4466cb6f13">   66</a></span>&#160;    <a class="code" href="classCoapClient.html">CoapClient</a> *<a class="code" href="classCoapServer.html#a5eb9e35199e0e9d72765ca4466cb6f13">get_client</a>();</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="classCoapServer.html#af58cf02cfa2575c558e04fdffec4403c">   75</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classCoapServer.html#af58cf02cfa2575c558e04fdffec4403c">add_resource</a>(<a class="code" href="classEddieResource.html">EddieResource</a> *resource);</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
<div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="classCoapServer.html#aa03a8a20c841396f698a541e87da3b5e">   81</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classCoapServer.html#aa03a8a20c841396f698a541e87da3b5e">run</a>();</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classCoapServer.html#a5c7f9c829a2809bbcdd737618814c9fd">   87</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classCoapServer.html#a5c7f9c829a2809bbcdd737618814c9fd">start_server</a>();</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div>
<div class="line"><a name="l00093"></a><span class="lineno"><a class="line" href="classCoapServer.html#a5b8430f0776f3d81d559bf056164cbc2">   93</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classCoapServer.html#a5b8430f0776f3d81d559bf056164cbc2">stop_server</a>();</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="classCoapServer.html#ada9e1dc9ce93d16e4392ebe8ac3649f1">  100</a></span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classCoapServer.html#ada9e1dc9ce93d16e4392ebe8ac3649f1">get_resources_in_linkformat</a>();</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div>
<div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="classCoapServer.html#a868d080db89c74cce694ec370b38c01e">  107</a></span>&#160;    [[nodiscard]] <span class="keyword">const</span> std::string &amp;<a class="code" href="classCoapServer.html#a868d080db89c74cce694ec370b38c01e">get_my_ip</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160; </div>
<div class="line"><a name="l00113"></a><span class="lineno"><a class="line" href="classCoapServer.html#a860496fc1f6bcfe099f486af92876094">  113</a></span>&#160;    [[nodiscard]] <span class="keyword">const</span> std::string &amp;<a class="code" href="classCoapServer.html#a860496fc1f6bcfe099f486af92876094">get_my_port</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div>
<div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="classCoapServer.html#af832d2ff6a571e8dd043f9de79f71d47">  119</a></span>&#160;    [[nodiscard]] coap_context_t *<a class="code" href="classCoapServer.html#af832d2ff6a571e8dd043f9de79f71d47">get_context</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div>
<div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="classCoapServer.html#ad6a18dddcb2e935b6d691f8fc3e2f067">  125</a></span>&#160;    [[nodiscard]] <span class="keywordtype">bool</span> <a class="code" href="classCoapServer.html#ad6a18dddcb2e935b6d691f8fc3e2f067">is_ipv6</a>() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;};</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160; </div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="preprocessor">#endif </span><span class="comment">//EDDIE_COAPSERVER_H</span></div>
<div class="ttc" id="aclassCoapClient_html"><div class="ttname"><a href="classCoapClient.html">CoapClient</a></div><div class="ttdef"><b>Definition:</b> CoapClient.h:24</div></div>
<div class="ttc" id="aclassCoapServer_html"><div class="ttname"><a href="classCoapServer.html">CoapServer</a></div><div class="ttdef"><b>Definition:</b> CoapServer.h:26</div></div>
<div class="ttc" id="aclassCoapServer_html_a5128aef62364279915b14a50205c1a68"><div class="ttname"><a href="classCoapServer.html#a5128aef62364279915b14a50205c1a68">CoapServer::~CoapServer</a></div><div class="ttdeci">~CoapServer()</div></div>
<div class="ttc" id="aclassCoapServer_html_a5b8430f0776f3d81d559bf056164cbc2"><div class="ttname"><a href="classCoapServer.html#a5b8430f0776f3d81d559bf056164cbc2">CoapServer::stop_server</a></div><div class="ttdeci">int stop_server()</div></div>
<div class="ttc" id="aclassCoapServer_html_a5c7f9c829a2809bbcdd737618814c9fd"><div class="ttname"><a href="classCoapServer.html#a5c7f9c829a2809bbcdd737618814c9fd">CoapServer::start_server</a></div><div class="ttdeci">int start_server()</div></div>
<div class="ttc" id="aclassCoapServer_html_a5eb9e35199e0e9d72765ca4466cb6f13"><div class="ttname"><a href="classCoapServer.html#a5eb9e35199e0e9d72765ca4466cb6f13">CoapServer::get_client</a></div><div class="ttdeci">CoapClient * get_client()</div></div>
<div class="ttc" id="aclassCoapServer_html_a860496fc1f6bcfe099f486af92876094"><div class="ttname"><a href="classCoapServer.html#a860496fc1f6bcfe099f486af92876094">CoapServer::get_my_port</a></div><div class="ttdeci">const std::string &amp; get_my_port() const</div></div>
<div class="ttc" id="aclassCoapServer_html_a868d080db89c74cce694ec370b38c01e"><div class="ttname"><a href="classCoapServer.html#a868d080db89c74cce694ec370b38c01e">CoapServer::get_my_ip</a></div><div class="ttdeci">const std::string &amp; get_my_ip() const</div></div>
<div class="ttc" id="aclassCoapServer_html_aa03a8a20c841396f698a541e87da3b5e"><div class="ttname"><a href="classCoapServer.html#aa03a8a20c841396f698a541e87da3b5e">CoapServer::run</a></div><div class="ttdeci">int run()</div></div>
<div class="ttc" id="aclassCoapServer_html_ad5149c00a7b9fde3bbaac8f36d2c89ee"><div class="ttname"><a href="classCoapServer.html#ad5149c00a7b9fde3bbaac8f36d2c89ee">CoapServer::CoapServer</a></div><div class="ttdeci">CoapServer(const char *host, const char *port)</div></div>
<div class="ttc" id="aclassCoapServer_html_ad6a18dddcb2e935b6d691f8fc3e2f067"><div class="ttname"><a href="classCoapServer.html#ad6a18dddcb2e935b6d691f8fc3e2f067">CoapServer::is_ipv6</a></div><div class="ttdeci">bool is_ipv6() const</div></div>
<div class="ttc" id="aclassCoapServer_html_ada9e1dc9ce93d16e4392ebe8ac3649f1"><div class="ttname"><a href="classCoapServer.html#ada9e1dc9ce93d16e4392ebe8ac3649f1">CoapServer::get_resources_in_linkformat</a></div><div class="ttdeci">static std::string get_resources_in_linkformat()</div><div class="ttdoc">Get the resources added into the server in link format.</div></div>
<div class="ttc" id="aclassCoapServer_html_af58cf02cfa2575c558e04fdffec4403c"><div class="ttname"><a href="classCoapServer.html#af58cf02cfa2575c558e04fdffec4403c">CoapServer::add_resource</a></div><div class="ttdeci">int add_resource(EddieResource *resource)</div></div>
<div class="ttc" id="aclassCoapServer_html_af832d2ff6a571e8dd043f9de79f71d47"><div class="ttname"><a href="classCoapServer.html#af832d2ff6a571e8dd043f9de79f71d47">CoapServer::get_context</a></div><div class="ttdeci">coap_context_t * get_context() const</div></div>
<div class="ttc" id="aclassEddieResource_html"><div class="ttname"><a href="classEddieResource.html">EddieResource</a></div><div class="ttdef"><b>Definition:</b> eddie.h:82</div></div>
<div class="ttc" id="aclassThreadSafeMap_html"><div class="ttname"><a href="classThreadSafeMap.html">ThreadSafeMap&lt; std::string, coap_resource_t * &gt;</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
